﻿using System;
using Telerik.Windows.Diagrams.Core;

namespace WpfExample
{
	public class MySnappingEngine : SnappingEngine
	{
		////protected override MatchingInfo GetHorizontalMatchingOverride(SnappingItem itemToSnap, SnappingItem staticItem)
		////{
		////	//// Use this method to implement custom snapping on the horizontal axis.
		////	return base.GetHorizontalMatchingOverride(itemToSnap, staticItem);
		////}

		protected override MatchingInfo GetVerticalMatchingOverride(SnappingItem itemToSnap, SnappingItem staticItem)
		{
			{
				var result = new MatchingInfo(double.NaN);

				var deltaLL = staticItem.CurrentBounds.Left - itemToSnap.CurrentBounds.Left;
				var deltaLR = staticItem.CurrentBounds.Left - itemToSnap.CurrentBounds.Right;
				var deltaRL = staticItem.CurrentBounds.Right - itemToSnap.CurrentBounds.Left;
				var deltaRR = staticItem.CurrentBounds.Right - itemToSnap.CurrentBounds.Right;

				var distanceToLeftLine = Math.Abs(deltaLL) < Math.Abs(deltaLR) ? deltaLL : deltaLR;
				var distanceToRightLine = Math.Abs(deltaRL) < Math.Abs(deltaRR) ? deltaRL : deltaRR;

				if (distanceToLeftLine == distanceToRightLine)
				{
					result.Delta = distanceToLeftLine;
					result.AddMatchingPoint(staticItem.CurrentBounds.Left);
					result.AddMatchingPoint(staticItem.CurrentBounds.Right);
					result.AddMatchingPoint((staticItem.CurrentBounds.Right + staticItem.CurrentBounds.Left)/2);
					result.AddMatchingPoint(staticItem.CurrentBounds.Right + 50);
				}

				else if (Math.Abs(distanceToRightLine) < Math.Abs(distanceToLeftLine))
				{
					result.Delta = distanceToRightLine;
					result.AddMatchingPoint(staticItem.CurrentBounds.Right);
				}
				else
				{
					result.Delta = distanceToLeftLine;
					result.AddMatchingPoint(staticItem.CurrentBounds.Left);
				}

				return result;
			}


		}
	}
}
